overlay: run unionmount testsuite test cases
[xfstests-dev.git] / tests / ext4 / 030
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2017-2018 Intel Corporation.  All Rights Reserved.
4 #
5 # FS QA Test ext4/030
6 #
7 # This is a regression test for kernel patch:
8 #   ext4: prevent data corruption with journaling + DAX
9 # created by Ross Zwisler <ross.zwisler@linux.intel.com>
10 #
11 seq=`basename $0`
12 seqres=$RESULT_DIR/$seq
13 echo "QA output created by $seq"
14
15 here=`pwd`
16 tmp=/tmp/$$
17 status=1        # failure is the default!
18 trap "_cleanup; exit \$status" 0 1 2 3 15
19
20 _cleanup()
21 {
22         cd /
23         rm -f $tmp.*
24 }
25
26 # get standard environment, filters and checks
27 . ./common/rc
28 . ./common/filter
29
30 # remove previous $seqres.full before test
31 rm -f $seqres.full
32
33 # Modify as appropriate.
34 _supported_os Linux
35 _supported_fs ext4
36 _require_scratch_dax
37 _require_test_program "t_ext4_dax_journal_corruption"
38 _require_command "$CHATTR_PROG" chattr
39
40 # real QA test starts here
41 _scratch_mkfs > $seqres.full 2>&1
42
43 # In order to get our failure condition consistently we need to turn off
44 # delayed allocation.  With delayed allocation on this simple test will pass,
45 # but we would almost certainly see data corruption down the road as the
46 # contents of the journal would conflict with the DAX data.
47 _scratch_mount "-o dax,nodelalloc" >> $seqres.full 2>&1
48
49 $here/src/t_ext4_dax_journal_corruption $CHATTR_PROG $SCRATCH_MNT/testfile
50
51 if [[ $? != 0 && $? != 77 ]]; then
52         echo "Test failed, status $?"
53         exit 1
54 fi
55
56 # success, all done
57 echo "Silence is golden"
58 status=0
59 exit